import abc
from ..utils import TrackerEvaluationException as TrackerEvaluationException
from _typeshed import Incomplete
from abc import ABC, abstractmethod

class _BaseDataset(ABC, metaclass=abc.ABCMeta):
    tracker_name: Incomplete
    @abstractmethod
    def __init__(self): ...
    @staticmethod
    @abstractmethod
    def get_default_dataset_config(): ...
    @abstractmethod
    def get_preprocessed_seq_data(self, raw_data: dict): ...
    @classmethod
    def get_class_name(cls): ...
    def get_name(self): ...
    def get_eval_info(self): ...
    def get_raw_seq_data(self, seq: str): ...
